/**Cartoon PopUps 
 * Author:Cat
 * Email:cat@ratrobot.com
 * Version:2.0
 * Description:
 */
//TODO:Version 3.0 Multiple lines of text
//TODO:Version 3.0 Generate HTML for page.
//TODO:Version 3.0 Maybe change the talkPoint so that the border is at the same spot as talkPoint.
//TODO:Version 3.0 Change colorBuilder and FontBuilder to checkSet and use stringToArray.
//TODO:Version 3.0 &nbsp; for the popup so that you can control the size of popup.
//TODO:Version 3.0 Native fonts.
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.util.*;

/**<p>Shows a cartoon bubble or think bubble with the text of your 
 * choice in it when the mouse is over the image link. This is a very old
 * (several years) applet and is no longer under active development.
 * </p>
 *
 * <p>It is available for any purpose from my website 
   <a href="http://www.ratrobot.com">ratrobot.com</a> under the terms of the 
 * <a href="http://www.fsf.org/licenses/licenses.html">General Public License</a>
 * </p>
 *
 * <p>All of the code was written several years ago when I was just starting to
 * program in Java so isn't of very good quality. If you would like to take the
 * time to improve it go ahead. 
 * </p>
 * @author Cat
 * @version 2.0
 */
public class Cartoon_v2 extends Applet implements MouseMotionListener,MouseListener,Runnable
{
	private Graphics m_offscreen;
	private Image m_pic,m_back,m_workspace;
	private FontMetrics m_fm;
	private Font m_ft;
	private Color m_coFont,m_coPopup,m_coBorder;
	private URL m_url;
	private Cursor m_cursor;
	private Thread m_loader;
	private String m_strText,m_strTarget;
	private String[] m_strPopUpStyle;
	private String m_strTalkPoint;
	private int m_nPicWidth,m_nPicHeight;
	private int m_nPicX,m_nPicY,m_nPopX,m_nPopY,m_nBorder;
	private int m_popUpWidth,m_popUpHeight;
	private boolean m_boPopup,m_boRatrobot,m_boSwap;
	
	private final String m_strRATROBOT = " ratrobot.com ";
	private	final Font m_ftSMALL = new Font("serif",Font.PLAIN,10);
	
	public void init()
	{
		//Initialise the member variables	
		m_popUpWidth = 100;
		m_popUpHeight = 100;
		m_strText="<param name=\"text\" value=\"Your message\">";
		m_strTarget = "_top";
		m_nPopX = 0;					//x position of popup
		m_nPopY = 0;					//y position of popup
		m_nPicX = 0;					//x position of picture
		m_nPicY = 0;					//y position of picture
		m_nBorder = checkSet("border",2);
		m_boPopup = false;
		m_boRatrobot = true;
		m_boSwap = false;
		m_strPopUpStyle = stringToArray(checkSet("popupstyle","oval"),",");
		m_strTalkPoint = checkSet("talkpoint","bottomright");
		m_coFont = colorBuilder("fontcolor");
		m_coBorder = colorBuilder("bordercolor");
		m_coPopup = colorBuilder("popupcolor");
		m_ft = fontBuilder();
		m_cursor = new Cursor(Cursor.HAND_CURSOR);
		m_workspace = createImage(getSize().width,getSize().height);
		m_offscreen = m_workspace.getGraphics();
		
		
		//Create the local variables for init()
		String text,strUrl,author;
		StringTokenizer st;
			
		setBackground(colorBuilder("backgroundcolor"));
		
		//Offset the position to take account of the border width.
		m_nPopX += m_nBorder;
		m_nPopY += m_nBorder;
		
		text = getParameter("text");
		if (text != null)
		{
			m_strText = getParameter("text");
		}
		strUrl = getParameter("url");
		if (strUrl != null)
		{
			st = new StringTokenizer(strUrl,",");
			m_url = null;
			try
			{
				m_url = new URL(getDocumentBase(),st.nextToken());
				m_strTarget = st.nextToken();
			}
			catch (MalformedURLException e) 
			{
				m_strText = "Problem with your url";
			}
			catch (NoSuchElementException e)
			{
				//No target specified. Might be using the cartoonpopup with no link
				//on purpose so do nothing.
			}
			
		}
		author = getParameter("author");
		if  ((author != null)&&(author.equalsIgnoreCase("This Applet is powered by www.ratrobot.com")))
		{
			m_boRatrobot = false;
		}
		
		//Find the size of the popup so that it can be positioned.	
		m_offscreen.setFont(m_ft);
		m_fm = m_offscreen.getFontMetrics();
		m_popUpHeight = m_fm.getAscent()*3;
		m_popUpWidth = (int)Math.floor((double)m_fm.stringWidth(m_strText)*1.1);
		
		addMouseMotionListener(this);
		addMouseListener(this);
	}//End init()
	
	
	public void run()
	{
		//Threaded Applet needed so that I can load Applet smoothly
		//and display "Applet loading..." while images loading
		repaint();
		Thread thisThread = Thread.currentThread();					
		
		m_back = getWholeImage("background");
		m_pic = getWholeImage("image");
		
		//Can't go on if there is no m_pic
		if (thisThread == m_loader)
		{
			//Can't work out m_nPicWidth or m_nPicHeight until m_pic has finished loading
			m_nPicWidth = m_pic.getWidth(this);
			m_nPicHeight = m_pic.getHeight(this);
						
			this.setDefaults();												
		
			//Once everything is finished loading update the screen		
			repaint();
		}
	}//End run()
	
	public void start()
	{
		if (m_loader == null)
		{
			m_loader = new Thread(this);
			m_loader.start();
		}
	}
	
	public void stop()
	{
		if (m_loader != null)
		{
			m_loader = null;
		}
	}
	
	
	

	public void paint(Graphics screen)
	{
		super.paint(screen);
		
		//If a background image is loaded use it. Otherwise use the background color
		if (m_back != null)
		{
			backGround(m_offscreen,m_back);
		}
		else
		{
			m_offscreen.setColor(getBackground());
			m_offscreen.fillRect(0,0,getSize().width,getSize().height);
		}
		
		//If m_pic is loaded draw it. Otherwise show message while loading.
		//Notice the y Position of the image is measured from the bottom.
		if (m_pic != null)
		{
			m_offscreen.drawImage(m_pic,m_nPicX,getSize().height - (m_nPicHeight + m_nPicY),this);
		}
		else
		{
			m_offscreen.setColor(Color.black);
			m_offscreen.drawString("Applet loading...",0,getSize().height/2);
			this.drawLogo(m_coPopup,m_coFont);
		}
		if(m_boPopup)
		{
			this.drawPopup();
		}
		if(m_boRatrobot)
		{
			if(!m_boSwap)
			{
				this.drawLogo(m_coPopup,m_coFont);
			}
			else
			{
				this.drawLogo(m_coFont,m_coPopup);
			}
			m_boSwap = false;
		}
				
		//Draw the buffered images to the screen
		screen.drawImage(m_workspace,0,0,this);
	}

	public void update(Graphics screen)
	{
		paint(screen);
	}

	public void mouseMoved(MouseEvent e)
	{
		int mouseX = e.getX();
		int mouseY = e.getY();
				
		//if picture contains cursor show popup
		if ((mouseX > m_nPicX)&&(mouseX < (m_nPicX + m_nPicWidth))
				&&(mouseY < (getSize().height - m_nPicY) )
				&&(mouseY > (getSize().height - m_nPicHeight - 
                                                                m_nPicY)))
		{
			m_boPopup = true;
			this.setCursor(m_cursor);
			if (m_boRatrobot)
			{
			this.showStatus(m_url.toString());
			}
			else
			{
				this.showStatus(m_url.toString() + 
                 "                    || free applet from www.ratrobot.com ||");
			}
			repaint();
		}
		else
		{
			m_boPopup = false;
			this.setCursor(Cursor.getDefaultCursor());
			this.showStatus("");
			repaint();
		}
		
		m_offscreen.setFont(m_ftSMALL);
		m_fm = m_offscreen.getFontMetrics();
		if( (mouseX < m_fm.stringWidth(m_strRATROBOT)) && 
			(mouseY > getSize().height - (m_fm.getHeight() + 1) ))
		{
			showStatus("free applet from www.ratrobot.com");
			m_boPopup = false;
			m_boSwap = true;
			this.setCursor(m_cursor);
			repaint();
		}
	
	} 
	public void mousePressed(MouseEvent e)
	{
		int mouseX = e.getX();
		int mouseY = e.getY();
		AppletContext browser = getAppletContext();
		URL url = null;
		try
		{
			url = new URL("http://www.ratrobot.com/");
		}
		catch (MalformedURLException mue){}
		
		//if picture contains cursor follow link
		if ((mouseX < m_fm.stringWidth(m_strRATROBOT)) && 
			(mouseY > getSize().height - (m_fm.getHeight() + 1) ))
		{
			browser.showDocument(url);
		}
		else if ((mouseX > m_nPicX)&&(mouseX < (m_nPicX + m_nPicWidth))
				&&(mouseY < (getSize().height - m_nPicY) )
				&&(mouseY > (getSize().height - m_nPicHeight - m_nPicY)))
		{
		//	AppletContext browser = getAppletContext();
			browser.showDocument(m_url,m_strTarget);
		}
	}
        
	public void mouseExited (MouseEvent e)
	{
		
		//cursor leaves picture area without entering applet
		m_boPopup = false;
		repaint();
	}

	public void mouseEntered (MouseEvent e){}
	public void mouseDragged(MouseEvent e){}
	public void mouseClicked(MouseEvent e){}
	public void mouseReleased(MouseEvent e){}
	
	/**Draw the popup to the graphics object.
	 */
	private void drawPopup()
	{
		int nThinkWidth = (int)Math.round((double)m_popUpWidth/8.0);	
		int nThinkHeight = (int)Math.round((double)m_popUpHeight/8.0);
		int[] x = {m_nPopX + m_popUpWidth ,m_nPopX + m_popUpWidth*1/4,
					m_nPopX + m_popUpWidth*4/6};		
		int[] y = {m_nPopY + m_popUpHeight + m_popUpHeight*1/3,m_nPopY + m_popUpHeight/2,
					m_nPopY + m_popUpHeight/2};		
		int[] x1 = new int[3];
		int[] y1 = new int[3];
		int nMin = Math.min(nThinkWidth,nThinkHeight);	
		
		m_offscreen.setFont(m_ft);
		m_fm = m_offscreen.getFontMetrics();
		
		makeTalkPointBorder(x,y,x1,y1, - m_nBorder);
		
		//The arrays depend on the talkPoint position.
		transformArrays(x,y);
		transformArrays(x1,y1);
		
		m_offscreen.setColor(m_coBorder);
		
		//draw the border of the think,talk,none.
		if((m_strPopUpStyle.length > 1)&&(m_strPopUpStyle[1].equalsIgnoreCase("think")))
		{			
			drawShape(x[0] - m_nBorder -nMin,y[0] - m_nBorder - nMin,nMin*2 + 2*m_nBorder
					  ,nMin*2 + 2*m_nBorder);			
		}		
		else if((m_strPopUpStyle.length > 1)&&(m_strPopUpStyle[1].equalsIgnoreCase("none")))
		{
			//do nothing
		}
		else 
		{
			m_offscreen.fillPolygon(x1,y1,3);	
		}

		//draw the body of the popup border.
		drawShape(m_nPopX - m_nBorder,m_nPopY - m_nBorder,m_popUpWidth
								+ 2*m_nBorder,m_popUpHeight + 2*m_nBorder);
		
		m_offscreen.setColor(m_coPopup);
		
		//draw the talk,think,none body.
		if((m_strPopUpStyle.length > 1)&&(m_strPopUpStyle[1].equalsIgnoreCase("think")))
		{			
			if(!m_strPopUpStyle[0].equalsIgnoreCase("cloud"))
			{
				drawShape(x[0] - nMin,y[0] - nMin,nMin*2,nMin*2);
			}
		}		
		else if((m_strPopUpStyle.length > 1)&&(m_strPopUpStyle[1].equalsIgnoreCase("none")))
		{			
			
		}
		else
		{
			m_offscreen.fillPolygon(x,y,3);
		}
		
		//draw the body of the popup body.
		if(!m_strPopUpStyle[0].equalsIgnoreCase("cloud"))
		{			
			drawShape(m_nPopX ,m_nPopY ,m_popUpWidth,m_popUpHeight);
		}
		
		//draw the text.
		m_offscreen.setColor(m_coFont);
		m_offscreen.drawString(m_strText,m_nPopX + 
									 (m_popUpWidth/2 - m_fm.stringWidth(m_strText)/2)
									,m_nPopY + m_popUpHeight/2 + m_fm.getAscent()/2 );
	}//end drawPopUp()

	/**Draws the shape that is determined by the m_strPopUpStyle String.
	 * 
	 * @param x the x coordinate of the top left corner of its bounding rectangle.
	 * @param y the y coordinate of the top left corner of its bounding rectangle.
	 * @param nWidth the width of the shape.
	 * @param nHeight the height of the shape.
	 */
	private void drawShape(int x,int y,int nWidth,int nHeight)
	{
		if((m_strPopUpStyle.length > 0)&&(m_strPopUpStyle[0].equalsIgnoreCase("cloud")))
		{
			//Short term fix the size of the border is added to the width and height
			//of the shape in drawPopup() for the background. Cloud is drawn differently 
			drawCloud(m_offscreen,x + m_nBorder,y + m_nBorder,
					  nWidth - 2*m_nBorder,nHeight - 2*m_nBorder,m_nBorder,m_coPopup,m_coBorder);
		}
		else
		{
			double dPercent = 1;//Bugfix
			
			if(m_strPopUpStyle[0].equalsIgnoreCase("rectangle"))
			{
				dPercent = 0;
			}
			else if(m_strPopUpStyle[0].equalsIgnoreCase("roundrectangle"))
			{
				try
				{
					dPercent = (double)Integer.parseInt(m_strPopUpStyle[2])/100.0;
				}
				catch(Exception e)
				{
					dPercent = 0.30;//Bugfix
				}
			}
			m_offscreen.fillRoundRect(x,y,nWidth,nHeight,(int)Math.round((double)nWidth*dPercent),
									  (int)Math.round((double)nHeight*dPercent));
		}
	}//end drawShape()
	
	/**Set the default positions of the image and popup.
	 */
	private void setDefaults()
	{
		//Need to take the circles on the edge of the cloud for default pos.
		int nCloudEdge = 0;
		if(m_strPopUpStyle[0].indexOf("cloud") != -1)
		{
			nCloudEdge = (int)Math.ceil((double)(m_popUpWidth + m_popUpHeight)/30.0);
		}
		
		m_nPicY = checkSet("imagey",0);
		m_nPicX = checkSet("imagex",m_popUpWidth + m_nBorder*2 + 2*nCloudEdge);
		m_nPopY = checkSet("popupy",(getSize().height - 
									 (m_nPicHeight + m_nPicY))  -  m_popUpHeight/2);
		m_nPopX = checkSet("popupx",m_nPicX - ( m_popUpWidth + m_nBorder + nCloudEdge));
		if(m_strTalkPoint.indexOf("left") != -1)
		{
			m_nPicX = checkSet("imagex",0);
			m_nPopX = checkSet("popupx",m_nPicX + m_nPicWidth + m_nBorder);
		}
		if(m_strTalkPoint.indexOf("top") != -1)
		{
			m_nPopY = checkSet("popupy",- m_nPicY + getSize().height 
										- m_popUpHeight - m_nBorder - nCloudEdge);
		}
	}//end setDefaults()

	/**Gets the image and waits for the whole image before returning.
	 */
	private Image getWholeImage(String strParam)
	{
		Image iTemp = null;
		MediaTracker track = new MediaTracker(this);
		
		iTemp = getImage(getDocumentBase(),getParameter(strParam));
		if (iTemp != null)
		{
			track.addImage(iTemp,1);
			try
			{
				track.waitForID(1);
			}
			catch (InterruptedException e) {}
			
			//Once the image is loaded update screen.
			repaint();
		}
		return iTemp;
	}//end getWholeImage()
	
	/**Try to get the value of the parameter from the web page if there is none 
	 * return the default.
	 */
	private int checkSet(String strParameter,int nDefault)
	{
		String strParam = getParameter(strParameter);
		int nValue;
		
		try
		{
			nValue = Integer.parseInt(strParam);
		}
		catch (NumberFormatException e)
		{
			nValue = nDefault;
		}		
		return nValue;
	}//end checkSet()
	
	private String checkSet(String strParameter,String strDefault)
	{
		String strValue = strDefault;
		String strParam = getParameter(strParameter);
		
		if(strParam != null)
		{
			strValue = strParam;	
		}	
		return strValue;		
	}//end checkSet()
	
	/**Draw the ratrobot.com logo to the buffered graphics object.
	 * Can't use the member colors as I want to be able to flip colors 
	 * on mouse over.
	 */
	private void drawLogo(Color color1,Color color2)
	{
		m_offscreen.setColor(color1);
		m_offscreen.setFont(m_ftSMALL);
		m_fm = m_offscreen.getFontMetrics();
		m_offscreen.fillRoundRect(0,getSize().height - (m_fm.getHeight() + 1),
								  m_fm.stringWidth(m_strRATROBOT),
									m_fm.getHeight(),10,10);
		m_offscreen.setColor(color2);
		m_offscreen.drawRoundRect(0,getSize().height - (m_fm.getHeight() + 1),
								  m_fm.stringWidth(m_strRATROBOT),
									m_fm.getHeight(),10,10);
		m_offscreen.drawString(m_strRATROBOT,0,getSize().height - (m_fm.getDescent() + 1));
	}//end drawLogo()
		
	/**Take a String and return an array containing the Tokens
	 * 
	 * @param string the string to be broken up and returned as an array of strings.
	 * @param strSeparator the Token separator.
	 */
	private String[] stringToArray(String string,String strSeparator)
	{
		StringTokenizer st = new StringTokenizer(string,strSeparator);
		String[] strTokens = new String[st.countTokens()];
		for(int i = 0; i < strTokens.length ; i++)
		{
			try
			{
				strTokens[i] = st.nextToken();
			}
			catch(NoSuchElementException nse)
			{
				strTokens[i] = "";
			}
		}
		return strTokens;
	}//end stringToArray()
	
	/**Draws a tiled background ,useing "pic", to Graphics object "page"
	 * 
	 * @param page The graphics object that I draw to 
	 * @param pic The image that 	
	 */
	private void backGround(Graphics page,Image pic)
	{
		int imageX,imageY,appletX,appletY,xTotal,yTotal;
		
		xTotal = 0;
		yTotal = 0;
		imageX = pic.getWidth(this);
		imageY = pic.getHeight(this);
		appletX = getSize().width;
		appletY = getSize().height;
		if ((imageX != -1)&&(imageY != -1))
		{
			while (xTotal < appletX)
			{
				yTotal = 0;
				while (yTotal < appletY)
				{
					page.drawImage(pic,xTotal,yTotal,this);
					yTotal += imageY;
				}
				xTotal += imageX;
			}
		}
	}
	
	/**Get's the font parameter and returns the font.
	 */
	private Font fontBuilder()
	{
		StringTokenizer st;
		String strTemp,strStyle;
		String strFont = "Serif";
		int nStyle = Font.PLAIN;
		int nSize = 12;
		
		strTemp = getParameter("font");
		
		try
		{
			st = new StringTokenizer(strTemp,",",false);	
			strFont = st.nextToken();
			strStyle = st.nextToken();
			if( strStyle.equalsIgnoreCase("bold"))
			{
				nStyle += Font.BOLD; 
			}
			else if(strStyle.equalsIgnoreCase("italic"))
			{
				nStyle += Font.ITALIC;	
			}
			else if(strStyle.equalsIgnoreCase("bolditalic"))
			{
				nStyle += Font.ITALIC + Font.BOLD;
			}
			try
			{
				nSize = Math.abs(Integer.parseInt(st.nextToken()));
			}
			catch(NumberFormatException e)
			{ 	
			}
		}
		catch(Exception e){	}
		Font font = new Font(strFont,nStyle,nSize);
		
		return font;
	}//end fontBuilder()
	
	/**Gets the color parameter and returns the color.
	 */
	private Color colorBuilder(String strParam)
	{
		Color c = Color.white;
		try
		{
			StringTokenizer st = new StringTokenizer(getParameter(strParam),",");
			c = new Color(Integer.parseInt(st.nextToken()),
										   Integer.parseInt(st.nextToken()),
										   Integer.parseInt(st.nextToken()));	
		}
		catch (Exception e)
		{	
			if(strParam.equalsIgnoreCase("fontcolor")||strParam.equalsIgnoreCase("bordercolor"))
			{
				c =  Color.black;
			}
		}
		return c;
	}//end colorBuilder()
	
	/**Transform the arrays that make up the talk point. The position of the points depends on the 
	 * value of m_strTalkPoint. Because the arrays are being passed by reference I don't need to 
	 * return any value.
	 * 
	 * @param  xArray the array of x points that will make up the polygon.
	 * @param  yArray the array of y points that will make up the polygon.
	 */
	private void transformArrays(int[] xArray,int[] yArray)
	{
		if ((m_strTalkPoint.equalsIgnoreCase("topleft"))
			||(m_strTalkPoint.equalsIgnoreCase("topright")))
		{
			flipArray(yArray,m_nPopY + m_popUpHeight/2);
		}
		if ((m_strTalkPoint.equalsIgnoreCase("topleft"))
			||(m_strTalkPoint.equalsIgnoreCase("bottomleft")))
		{
			flipArray(xArray,m_nPopX + m_popUpWidth/2);
		}
	}//end transformArrays()

	/**Flips the values in an array relative to the point.
	 */
	private void flipArray(int[] array,int point)
	{
		for (int i = 0 ; i < array.length ; i++)
		{
			array[i] -= point;
			array[i] *= -1;
			array[i] += point;
		}
	}//end flipArray()
	
//end scaleArray()
	
/***********************************************************************************/
/************************* Methods used to draw Cloud ******************************/
	
	/**Draws a cloud made up of an ellipse with it's top left corner at x,y and with the 
	 * bounding rectangle haveing width "nWidth" and height "nHeight". The total width 
	 * includeing the edge with radius = (a + b)/15.0 
	 * "nWidth + 2*radius" and the total height is "nHeight + 2*radius".
	 * 
	 * @param x the x coordinate of the top left corner of the bounding rectangle for the 
	 * ellipse (the cloud body).
	 * @param x the y coordinate of the top left corner of the bounding rectangle for the 
	 * ellipse (the cloud body).
	 * @param nWidth The width of the bounding rectangle for the ellipse.(not the cloud as a 
	 * whole.
	 * @param nHeight The height of the bounding rectangle for the ellipse.(not the cloud as 
	 * a whole.
	 * @param graphics Graphics object to draw the cloud on.
	 * @param border The width of the cloud border in pixels.
	 * @param bodyColor The color of the body of the cloud.
	 * @param borderColor The color of the border of the cloud.
	 */
	private void drawCloud(Graphics graphics,int x,int y,int nWidth,int nHeight,int border,
								Color bodyColor,Color borderColor)
	{
		boolean boHalfDone = false;	
		Vector v = new Vector(100);
		int a = (int)Math.round((double)nWidth/2.0);
		int b = (int)Math.round((double)nHeight/2.0);
		graphics.setColor(borderColor);	
		
		//If the ratio of the ellipse is to small it causes an infinite loop.
		if( (a > 10 )&&( b > 10))
		{
			if( 25.0 < (double)a/(double)b)
			{
				b = (int)Math.round((double)a/25.0);
			}
			if( 25.0 < (double)b/(double)a)
			{
				a = (int)Math.round((double)b/25.0) ;
			}
				
			int radius = (int)Math.ceil((double)(a + b)/15.0);
				
			//Set the coordinates relative to the top left corner of screen.
			Point point = new Point(x,y + b);
							
			//Find all the points on the circumference of the ellipse.
			for(int i = 0 ;!(boHalfDone && ( point.y < y + b )); i++)
			{
				point = nextPoint(point,radius,a,b,x,y);
				v.addElement(point);
				if(point.y > y + b)
				{
					boHalfDone = true;
				}	
			}
				
			//Draw the cloud with the border first.
			drawCircles(v,graphics,radius + border);
			graphics.setColor(bodyColor);
			drawCircles(v,graphics,radius);
		}
		else
		{
			graphics.fillOval(x - border,y - border,2*a + 2*border,2*b + 2*border);
			graphics.setColor(bodyColor);
		}
		graphics.fillOval(x,y,2*a,2*b);
	}//end drawCloud()
	
	/**Takes a vector containing a series of points and draws circles at the points.
	 * 
	 * @param v The vector containing the points
	 * @param graphics The graphics object to draw the points to.
	 * @param radius The radius of the circles.
	 */
	private void drawCircles(Vector v,Graphics graphics,int radius)
	{
		for(int i = 0; i < v.size() ; i++)
		{
			Point point = (Point)v.elementAt(i);
			if(i%2 == 1)
			{
				graphics.fillOval(point.x - radius,
							point.y - radius,radius*2,radius*2);
			}
		}
	}//end drawCircles()
	
	/**Work out the width of the ellipse for a given value of y. All co-ordinates are 
	 * measured from the top left corner in the standard java co-ordinate system. You 
	 * can also use the same function to measure the height of an ellipse. You simply 
	 * exchange "a" for "b" and "x0,x" for "y0,y".e.g. ellipseWidth(b,a,x0,x) will 
	 * return the height of the ellipse center x0,y0 at horizontal position x.
	 * 
	 * @param a 2*a is the horizontal axis of the ellipse.
	 * @param b 2*b is the vertical axis of the ellipse.
	 * @param y0 The y-coordinate of the center of the ellipse.
	 * @param y The y-coordinate of the line of intercept with the ellipse.
	 */
	private int ellipseWidth(int a,int b,double y0,double y)
	{
		return  (int) Math.floor( 2*(double)a*Math.sqrt( 1 - 
					Math.pow(( y - (double)y0 - (double) b )/ (double)b,2)) );
	}//end ellipseWidth()
		
	/**Given the value of theta for a point on a circle center x0,y0 radius "radius" find the 
	 * "Point" in standard java coordinates of the point on the circumference.
	 * 
	 * @param theta Angle from the positive x-axis in the anti-clockwise direction.
	 * @param x0 the x-coordinate of the center of the circle.
	 * @param y0 the y-coordinate of the center of the circle.
	 * @param radius The radius of the circle.
	 */
	private Point workOutIntercept(double theta,int x0,int y0,int radius)
	{
		Point point = new Point(x0,y0);
		
		//distance relative to the center x0,y0 of the circle
		point.y = (int)Math.round( ((double)radius)*Math.sin(theta));
		point.x = (int)Math.round( ((double)radius)*Math.cos(theta));
		
		double alpha2 = Math.atan2(y0 - point.y,point.x - x0)*(180.0/Math.PI);//test
		
		//point relative to the top left corner in java coordinates
		point.x += x0;
		point.y = y0 - point.y;
		
		return point;
	}//end workOutIntercept()
	
	/**Check whether the given point x1,y1 is inside the given ellipse a,b,x0,y0.
	 * 
	 * @param a 2*a is the horizontal axis of the ellipse.
	 * @param b 2*b is the vertical axis of the ellipse.
	 * @param x0 is the x-coordinate of the top left corner of the bounding rectangle for 
	 * the ellipse.
	 * @param y0 the y-coordinate of the top left corner of the bounding rectangle for the
	 * ellipse.
	 * @param x1 the x-coordinate of the point.
	 * @param y1 the y-coordinate of the point.
	 */
	private boolean insideEllipse(int a,int b,int x0,int y0,int x1,int y1)
	{
		return ( Math.abs((y1 - b - y0)) <  ellipseWidth(b,a,x0,x1)/2 );
	}//end insideEllipse()
	
	/**Returns a point that is distance r away from the current point on the surface of 
	 * the ellipse. It is reached traveling in the clockwise direction.All the values are in 
	 * the standard Java co-ordinate system with the zero in the top left corner.
	 * 
	 * @param current the current Point.
	 * @param nRadius the radius of the circle used to find the next point on the circumference 
	 * of the ellipse.
	 * @param a the horizontal axis of the ellipse.
	 * @param b the vertical axis of the ellipse.
	 * @param x0 the x coordinate of the center of the ellipse.
	 * @param y0 the y coordinate of the center of the ellipse.
	 */
	private Point nextPoint(Point current,int nRadius,int a,int b,int x0,int y0)
	{
		double alpha = Math.atan2(y0 + b - current.y,current.x - x0 - a);
		Point workingPoint = new Point(current);
	
		do
		{
			workingPoint = workOutIntercept(alpha,current.x,current.y,nRadius);
			alpha -= Math.PI/180.0;
		}while(!insideEllipse(a,b,x0,y0,workingPoint.x,workingPoint.y));
		current = new Point(workingPoint);
		return current;
	}//end nextPoint()
	

/***********************************************************************************/
/************************* Methods used to draw talkpoint **************************/
	
	
	/**Given two arrays that represent the x and y coordinates of a triangle set the
	 * other arrays provide to be equal too a triangle of size the origin plus a border
	 * around the outside.
	 * 
	 * @param x the array that holds the x coordinates of the triangle
	 * @param y the array that holds the y coordinates of the triangle
	 * @param xb the array that holds the x coordinates of the border triangle
	 * @param yb the array that holds the y coordinates of the border triangle
	 */
	private void makeTalkPointBorder(int[] x,int[] y,int[] xb,int[] yb,int border)
	{
		double m12/*,m23*/,m31;
		double c12/*,c23*/,c31;
		double c12P/*,c23P*/,c31P;
		Point p1,p2,p3;
		
		//For this class the top intercept is used instead of the border intercept
		m12 = workOutGradient(x[0],x[1],y[0],y[1]);
	//	m23 = 0;//workOutGradient(x[1],x[2],y[1],y[2]);
		m31 = workOutGradient(x[2],x[0],y[2],y[0]);
		
		c12 = workOutIntercept(x[0],y[0],m12);
		/*c23 = y[1];//workOutIntercept(x[1],y[1],m23);*/
		c31 = workOutIntercept(x[2],y[2],m31);
		
		c12P = parellelIntercept(c12,m12,- border);
	//	c23P = y[1];//parellelIntercept(c23,m23,border);
		c31P = parellelIntercept(c31,m31,border);
		
		p1 = lineIntersection(m12,c12P,/*m23*/0,/*c23P*/y[1]);
		p2 = lineIntersection(/*m23*/0,/*c23P*/y[1],m31,c31P);
		p3 = lineIntersection(m31,c31P,m12,c12P);
		
		xb[0] = p1.x;
		xb[1] = p2.x;
		xb[2] = p3.x;
		yb[0] = p1.y;
		yb[1] = p2.y;
		yb[2] = p3.y;
	}
	
	/**Given two points in the Java graphics plane work out the gradient of the 
	 * line that connects them. Note as usual that the y axis is increasingly +ve 
	 * down the screen.
	 * 
	 * @param x1 the x coordinate of the first point
	 * @param x2 the x coordinate of the second point 
	 * @param y1 the y coordinate of the first point
	 * @param y2 the y coordinate of the second point
	 */
	private double workOutGradient(int x1,int x2,int y1,int y2)
	{
		double dGrad = ((double)y1 - y2)/((double)x1 - x2);
		return dGrad;
	}//end workOutGradient()
	
	/**Given a point on a line and the gradient of that line work out 
	 * the y intercept of the line.
	 * 
	 * @param x1 the x coordinate of the point.
	 * @param y1 the y coordinate of the point.
	 * @param gradient the gradient of the line that goes through the point.
	 */
	private double workOutIntercept(int x1,int y1,double gradient)
	{
		double dIntercept = (double)y1 - gradient*(double)x1;
		return dIntercept;
	}//end workOutIntercept()
	
	/**Given the intercept and gradient of a line return the intercept of a line parellel to it
	 * but "distance" away from it. If the distance is +ve then the line is on the more +ve side of 
	 * original line otherwise if it is -ve it is on the less +ve side.
	 * 
	 * @param intercept the intercept of the origin line.
	 * @param gradient the gradient of both lines.
	 * @param distance the distance between the lines.
	 */
	private double parellelIntercept(double intercept,double gradient,int distance)
	{
		intercept += (double)distance/Math.sin( Math.atan(gradient) + Math.PI/2.0) ;
		return intercept;
	}//ent parellelIntercept()
	
	/**Returns the point at which the two lines intersect.
	 * 
	 * @param m1 The gradient of the first line.
	 * @param c1 The y intercept of the first line.
	 * @param m2 The gradient of the second line.
	 * @param c2 The y intercept of the second line.
	 */
	private Point lineIntersection(double m1,double c1,double m2,double c2)
	{
		Point point = new Point((int)Math.round((c2 - c1)/(m1 - m2)),
								(int)Math.round(m1*((c2 - c1)/(m1 - m2)) + c1));
		return point;
	}
}
